import java.util.*;
import java.io.*;
import java.net.*;

public class ProcessRequest extends Thread {
    Socket sock;
    ProcessRequest(Socket ss){
    	sock=ss;
    }
    public void run(){
        try{
            InputStream ulaz = sock.getInputStream();
            OutputStream izlaz = sock.getOutputStream();

            ObjectInputStream oiss = new ObjectInputStream(ulaz);
            ObjectOutputStream ooss = new ObjectOutputStream(izlaz);

            Object zahtev = oiss.readObject();//sad ovde citam sta mi kljient salje, tj citam njegov zahtev
            String  sZahtev = (String) zahtev; //pretvotim Objekat zahtrev u String
            
            //ono sto mi je klijent poslao je ID tiketa, tako da ja na osnovu njega pristupam  TreeMap-u
            //sviTiketi i vadim onaj tiket koji odgovara datom klucu
            Tiket tt = (Tiket) ZareServer.sviTiketi.get(sZahtev);//mora i ovde da se kastuje jer metoda get vraca Object

            //sad sve pripremamo za slanje trazenog tiketa preko mreze
				
            ooss.writeObject(tt); //...i to je to, upravo je poslat objekat
            ooss.flush();

            ulaz.close();
            izlaz.close();
            ooss.close();
            oiss.close();   
        }catch(Exception e){}//...mora ovako, pogledajte sta ce se desiti ako se radi bez exception
    }
}
