/* e pa ovako... prvo trba uvesti java.util, java.io i java.net pakete, posle ti uvezio jos java.awt kad
*budes sirila 	 sisitem do komercijalnog nivoa ;)
*Uvezao sam java.util jer cu koristiti TreeMap... ta klasa je najzgodnija jer ce mi kljuc biti
*IDTiketa, a na osnovu njega cu dobijati objekat Tiket sa specificnim brojem
*/

import java.util.*;
import java.io.*;
import java.net.*;

public class ZareKlijent implements Serializable{
    public static void main(String args[]){
        OutputStream out;
        InputStream in;
	ObjectInputStream ois=null;
	ObjectOutputStream oos=null;
	try{
            //sada otvaramo uticnicu prema serveru koji se zove localhost
            //i koji osluskuje na portu 43
            Socket sock = new Socket("user",2223);
		
            //e sad... sad je potrebno da definisemo komponente uz pomoc kojih
            //server i klijent vide jedan drugoga. To su donje komponente in i out. Klijent pomocu
            //out komponente moze da "pise" po serveru, odnosno da umece ili da mu salje, odnosno da smesta 
            //u njegov adresni prostor neke poruke. Serverov adresni prostor moze biti na nekom drugom racunaru
            //ali tada ne otvaramo uticnicu sa localhost vec sa imenom drugog racunara
            //Klijent cita od servera odgovor preko komponente in... pogledajte kako je ona formirana...
            //InputStream in = sock.getInputStream(); dakle ja na ovaj nacin bukvalno uzimam iz serverskog adresnog prostora 
            //ono sto ce on meni poslati kao odgovor....ali oprez - ja jos uvek nisam definisao protokol po kome komuniciraju
            //klijent i server, samo sam otvorio kanale veze
	    out = sock.getOutputStream();
            in = sock.getInputStream();
                       
            //posto smo ovo uradili treba in i out "upakovati u celofan da bi lepse izgledali" :)
            //zapravo treba na osnovu njih inicijalizovati neke komponente iz klase java.io koje nam olaksavaju rad i dopisivanje
            //izmedju klijenta i servera.  Koliko sam ja shvatio in i out su u direktnoj sprezi sa hardverom koji obavlja
            //mreznu komunikaciju. Mi ne zelimo da se spustamo na taj nivo vec cemo ih obloziti saObjectOutputStream i
            //ObjectInputStream klasama kako ne bismo razmisljali u bajtovima i nulama i jedinicama, vec u Objektima
            //Naime kad radimo sa ObjectInputStream i ObjectOutputStream onda ne treba da razmislajmo o konverziji u nule i jedinice 
            //Ove klase konvertuju objekte automatski u nule i jedinice i salju ih preko mreze, 
            //a kada ih ne bi koristili, morali bi mi sami da se snalazimo
            //kako znamo i umemo pomocu OutputStream  i InputStream klasa
            //System.out.println("check0 "+args[0]);
            try{
                ois = new ObjectInputStream(in);
                oos = new ObjectOutputStream(out);
		Object zaSlanje = (Object)"A0";
                //verovali ili ne sa donjom naredbom saljemo serveru podatak koji smo uneli preko konzole
                oos.writeObject(zaSlanje);
                //oos.flush(); //ovo treba ne znam ni sam zasto
		//sada trebamo da procitamo njegov odgovor
                //Thread.sleep(2000);
                Object odgovor = ois.readObject();
                Tiket tick = (Tiket)odgovor;// ovde sada kastujemo(konvertujemo) objekat u njegovu pravu klasu, a to je Tiket
                
                System.out.println(tick);//pozivamo toString() metodu tiketa da bismo ga odstampali, odnosno da bi videli sta smo dobili

                in.close();
		out.close();
		oos.close();
		ois.close();
            }catch(IOException ioe){System.out.println("Zasto zezate servera "+ioe);}
        }catch(Exception e){System.out.println("Nesto ne valja  "+e);}
    }
}																																								 